File: common.css

package info (click to toggle)
firefox 147.0.3-1
  • links: PTS, VCS
  • area: main
  • in suites: sid
  • size: 4,683,320 kB
  • sloc: cpp: 7,607,359; javascript: 6,533,295; ansic: 3,775,223; python: 1,415,500; xml: 634,561; asm: 438,949; java: 186,241; sh: 62,752; makefile: 18,079; objc: 13,092; perl: 12,808; yacc: 4,583; cs: 3,846; pascal: 3,448; lex: 1,720; ruby: 1,003; php: 436; lisp: 258; awk: 247; sql: 66; sed: 54; csh: 10; exp: 6
file content (933 lines) | stat: -rw-r--r-- 25,697 bytes parent folder | download | duplicates (2)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
456
457
458
459
460
461
462
463
464
465
466
467
468
469
470
471
472
473
474
475
476
477
478
479
480
481
482
483
484
485
486
487
488
489
490
491
492
493
494
495
496
497
498
499
500
501
502
503
504
505
506
507
508
509
510
511
512
513
514
515
516
517
518
519
520
521
522
523
524
525
526
527
528
529
530
531
532
533
534
535
536
537
538
539
540
541
542
543
544
545
546
547
548
549
550
551
552
553
554
555
556
557
558
559
560
561
562
563
564
565
566
567
568
569
570
571
572
573
574
575
576
577
578
579
580
581
582
583
584
585
586
587
588
589
590
591
592
593
594
595
596
597
598
599
600
601
602
603
604
605
606
607
608
609
610
611
612
613
614
615
616
617
618
619
620
621
622
623
624
625
626
627
628
629
630
631
632
633
634
635
636
637
638
639
640
641
642
643
644
645
646
647
648
649
650
651
652
653
654
655
656
657
658
659
660
661
662
663
664
665
666
667
668
669
670
671
672
673
674
675
676
677
678
679
680
681
682
683
684
685
686
687
688
689
690
691
692
693
694
695
696
697
698
699
700
701
702
703
704
705
706
707
708
709
710
711
712
713
714
715
716
717
718
719
720
721
722
723
724
725
726
727
728
729
730
731
732
733
734
735
736
737
738
739
740
741
742
743
744
745
746
747
748
749
750
751
752
753
754
755
756
757
758
759
760
761
762
763
764
765
766
767
768
769
770
771
772
773
774
775
776
777
778
779
780
781
782
783
784
785
786
787
788
789
790
791
792
793
794
795
796
797
798
799
800
801
802
803
804
805
806
807
808
809
810
811
812
813
814
815
816
817
818
819
820
821
822
823
824
825
826
827
828
829
830
831
832
833
834
835
836
837
838
839
840
841
842
843
844
845
846
847
848
849
850
851
852
853
854
855
856
857
858
859
860
861
862
863
864
865
866
867
868
869
870
871
872
873
874
875
876
877
878
879
880
881
882
883
884
885
886
887
888
889
890
891
892
893
894
895
896
897
898
899
900
901
902
903
904
905
906
907
908
909
910
911
912
913
914
915
916
917
918
919
920
921
922
923
924
925
926
927
928
929
930
931
932
933
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

@import url("chrome://devtools/skin/splitters.css");
@namespace html url("http://www.w3.org/1999/xhtml");

:root {
  /* Bug 1458224: the initial `font-size` is different on Mac/Windows
   * (appears fixed to 11px) and Linux (bigger, depends on user settings).
   * Workaround: specify font-size on root, on form inputs, and whenever
   * we're using the `font` shorthand. */
  font: message-box;
  font-size: var(--theme-body-font-size);

  --tab-line-hover-color: light-dark(rgba(0, 0, 0, 0.2), rgba(255, 255, 255, 0.2));

  --tab-line-selected-color: var(--blue-50);
  --toggle-thumb-color: light-dark(white, var(--grey-40));
  --toggle-thumb-color-pressed: white;
  --toggle-track-color: var(--grey-50);
  --toggle-track-color-pressed: var(--blue-55);
  --toggle-track-border-color: transparent;
  /* In regular themes, the disabled style is handled by the lowered opacity,
     the colors fall back to their "default" values */
  --toggle-disabled-track-border-color: var(--toggle-track-border-color);
  --toggle-disabled-track-color-pressed: var(--toggle-track-color-pressed);
  --toggle-disabled-thumb-color: var(--toggle-disabled-thumb-color);
  --toggle-track-disabled-opacity: 0.5;
  /* We don't have distinct :hover style in regular themes, the colors fall back to their
     "default" values */
  --toggle-hover-track-color: var(--toggle-track-color);
  --toggle-hover-track-border-color: var(--toggle-track-border-color);
  --toggle-hover-track-color-pressed: var(--toggle-track-color-pressed);
  --toggle-hover-thumb-color: var(--toggle-thumb-color);

  --searchbox-no-match-background-color: light-dark(#ffe5e5, #402325);
  --searchbox-no-match-stroke-color: light-dark(var(--red-60), var(--red-50));
  --searchbox-background-color: transparent;
  --searchbox-border-color: transparent;

  --devtools-searchinput-clear-cross-color: transparent;
  --devtools-searchinput-clear-hover-cross-color: transparent;
  --devtools-searchinput-clear-opacity: 0.8;

  --devtools-twisty-size: 14px;

  /* Don't allow forced colors in DevTools if they're not supported */
  &:not([forced-colors-active]) {
    forced-color-adjust: none;
  }

  /* Forced Colors / High Contrast Mode specifics */
  &[forced-colors-active] {
    --toggle-track-color: ButtonFace;
    --toggle-track-color-pressed: ButtonText;
    --toggle-thumb-color: ButtonText;
    --toggle-thumb-color-pressed: ButtonFace;
    --toggle-track-border-color: ButtonText;
    --toggle-hover-track-color: SelectedItemText;
    --toggle-hover-track-border-color: SelectedItem;
    --toggle-hover-track-color-pressed: SelectedItem;
    --toggle-hover-thumb-color: SelectedItem;
    /* In High Contrast Mode, the opacity is not lowered, so the disabled style is
       handled by modifiying the colors */
    --toggle-disabled-track-border-color: GrayText;
    --toggle-disabled-track-color-pressed: GrayText;
    --toggle-disabled-thumb-color: GrayText;
    --toggle-track-disabled-opacity: 1;

    /* From High Contrast Mode guidelines:
       > Error inputs in our traditional design system use color to indicate they are destructive.
       > We cannot do this in HCM, so the default INPUT style should be used instead.
      Given this, we should use the default color.
    */
    --searchbox-no-match-stroke-color: var(--theme-icon-color);
    --searchbox-background-color: ButtonFace;
    --searchbox-border-color: ButtonText;

    --devtools-searchinput-clear-opacity: 1;
    --devtools-searchinput-clear-cross-color: ButtonFace;
    --devtools-searchinput-clear-hover-cross-color: SelectedItemText;
  }
}

:root.theme-light {
  color-scheme: light;
}

:root.theme-dark {
  color-scheme: dark;
}

:root[platform="mac"] {
  --monospace-font-family: Menlo, monospace;
}

:root[platform="win"] {
  --monospace-font-family: Consolas, monospace;
}

:root[platform="linux"] {
  --monospace-font-family: monospace;
}

/**
 * Customize the dark theme's scrollbar colors to avoid excessive contrast.
 */
:root.theme-dark {
  scrollbar-color: var(--grey-50) var(--theme-splitter-color);
}

/**
 * Customize scrollbar colors on Linux + light theme, to avoid visual conflicts
 * between the light theme and the selected GTK theme (see bug 1471163).
 * This removes GTK scrollbars and uses a fallback design (see bug 1464723).
 */
:root[platform="linux"].theme-light {
  scrollbar-color: var(--grey-40) var(--grey-20);
}

::selection {
  background-color: var(--theme-selection-background);
  color: var(--theme-selection-color);
}

.devtools-monospace {
  font-family: var(--monospace-font-family);
  font-size: var(--theme-code-font-size);
}

/**
 * For text that needs to be cut with an ellipsis …
 */
.devtools-ellipsis-text {
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

/**
 * Override global.css input styles
 */
html|input {
  margin: revert;
}

/**
 * Override wrong system font from forms.css
 * Bug 1458224: buttons use a wrong default font-size on Linux
 */
html|button,
html|select,
html|input {
  font: message-box;
  font-size: var(--theme-body-font-size);
}

/* Devtools rely on the old Gecko/HTML4 button hit testing */
html|button > * {
  pointer-events: none;
}

/* Prevent buttons from having a text selection highlight. Bug 1546366 */
button::selection {
  all: unset;
}

iframe {
  border: 0;
  min-width: 0;
  min-height: 0;
}

/* Autocomplete Popup */
.devtools-autocomplete-popup {
  overflow: hidden;

  /* Devtools autocompletes display technical english keywords and should be displayed
     using LTR direction. */
  direction: ltr !important;
}

/* Reset list styles. */
.devtools-autocomplete-popup ul {
  list-style: none;
}

.devtools-autocomplete-popup ul,
.devtools-autocomplete-popup li {
  margin: 0;
}

.devtools-autocomplete-listbox {
  --autocomplete-item-padding-inline: 8px;
  --autocomplete-item-color-swatch-size: 1em;
  --autocomplete-item-color-swatch-margin-inline: 5px;
  appearance: none !important;
  background-color: transparent;
  border-width: 0 !important;
  margin: 0;
  padding: 0;
  overflow-x: hidden;
  max-height: 20rem;
  box-sizing: border-box;
}

.devtools-autocomplete-listbox .autocomplete-item {
  width: 100%;
  box-sizing: border-box;
  background-color: transparent;
  color: var(--theme-popup-color);
  padding: 1px var(--autocomplete-item-padding-inline);
  cursor: default;
  text-overflow: ellipsis;
  white-space: pre;
  overflow: hidden;
}

.devtools-autocomplete-listbox .autocomplete-item > .initial-value,
.devtools-autocomplete-listbox .autocomplete-item > .autocomplete-value {
  margin: 0;
  padding: 0;
  float: inline-start;
}

.devtools-autocomplete-listbox .autocomplete-item > .autocomplete-postlabel {
  font-style: italic;
  float: inline-end;
  padding-inline-end: 3px;
}

.devtools-autocomplete-listbox .autocomplete-item > .autocomplete-count {
  text-align: end;
}

.devtools-autocomplete-listbox .autocomplete-swatch {
  cursor: pointer;
  border-radius: 50%;
  box-shadow: 0 0 0 1px #c4c4c4;
  width: var(--autocomplete-item-color-swatch-size);
  height: var(--autocomplete-item-color-swatch-size);
  vertical-align: middle;
  /* align the swatch with its value */
  margin-top: -1px;
  margin-inline: var(--autocomplete-item-color-swatch-margin-inline);
  display: inline-block;
  position: relative;
}

/* Rest of the dark and light theme */
.devtools-autocomplete-popup,
.tooltip-panel.devtools-autocomplete-popup,
.CodeMirror-hints,
.CodeMirror-Tern-tooltip {
  border: 1px solid var(--theme-popup-border-color);
  background-color: var(--theme-popup-background);
  color: var(--theme-popup-color);
}

.devtools-autocomplete-listbox .autocomplete-item:hover {
  background-color: var(--theme-popup-hover-background);
  color: var(--theme-popup-hover-color);
}

.devtools-autocomplete-listbox .autocomplete-selected,
.devtools-autocomplete-listbox .autocomplete-selected:hover {
  background-color: var(--theme-selection-background);
  color: var(--theme-selection-color);
}

/* In High Contrast Mode, we want to distinguish betweeen hover and selected items.
   Since hover is already adding a "SelectedItem" background we can't rely on the color
   here, so add an outline as we do for focused element. This follows the HCM design
   for dropdown (e.g. the Reader Mode voice selector) */
:root[forced-colors-active] .devtools-autocomplete-listbox .autocomplete-selected {
  outline: var(--theme-focus-outline);
  outline-offset: -1px;
  &:not(:hover) {
    background-color: unset;
    color: unset;
  }
}

.devtools-autocomplete-listbox .autocomplete-selected > .initial-value {
  font-weight: bold;
  :root[forced-colors-active] & {
    background-color: Mark;
    color: MarkText;
  }
}

/* Autocomplete list clone used for accessibility. */

.devtools-autocomplete-list-aria-clone {
  /* Cannot use display:none or visibility:hidden : screen readers ignore the element. */
  position: fixed;
  overflow: hidden;
  margin: 0;
  width: 0;
  height: 0;
}

.devtools-autocomplete-list-aria-clone li {
  /* Prevent screen readers from prefacing every item with 'bullet'. */
  list-style-type: none;
}

/* Keyboard focus highlight styles */

:focus-visible {
  outline: var(--theme-focus-outline);
  outline-offset: var(--theme-outline-offset);
  box-shadow: var(--theme-outline-box-shadow);

  /* override properties set in global-shared.css for links  */
  a& {
    outline-color: var(--theme-focus-outline-color) !important;
    outline-width: var(--theme-focus-outline-size) !important;
  }

  /* offset the outline for checkbox and radio buttons so it doesn't conflict with existing border */
  :is(input[type="radio"], input[type="checkbox"], checkbox)& {
    outline-offset: 2px;
  }

  :is(input[type="text"], input[type="search"], input:not([type]))& {
    outline-color: var(--theme-focus-textinput-outline-color);
  }
}

/* Toolbar buttons */
.devtools-togglebutton,
.devtools-button {
  appearance: none;
  background: transparent;
  border: none;
  border-radius: 2px;
  color: var(--theme-body-color);
  align-items: center;
  text-shadow: none;
  padding: 2px;
  margin: 1px;

  /* Button text should not wrap on multiple lines */
  white-space: nowrap;
}

.devtools-togglebutton {
  padding: 1px 6px;
  border-block: 2px solid transparent;
  /* Separate the outline from the button as it might have a similar background color */
  outline-offset: 2px;

  :root[forced-colors-active] & {
    border: 1px solid currentColor;
  }
}

/* Button with text */
.devtools-button:not(:empty) {
  padding-inline: 5px;
  background: var(--toolbarbutton-background);
}

/* Button icon */
.devtools-button::before {
  content: none;
  display: inline-block;
  vertical-align: middle;
  width: 16px;
  height: 16px;
  margin: 0 3px;
  color: var(--theme-icon-color);
  font-size: 11px;
  -moz-context-properties: fill;
  fill: currentColor;
  background-position: center;
  background-repeat: no-repeat;
}

/* Reveal the icon */
.devtools-button:empty::before {
  content: "";
}

.devtools-button:is(.checked, [aria-pressed="true"])::before {
  color: var(--theme-icon-checked-color);
}

/* Icon-only buttons */
.devtools-button:hover::before,
.devtools-button:is(.checked, [aria-pressed="true"])::before {
  opacity: 1;
}

/* Button states */
.devtools-button:disabled {
  pointer-events: none;

  &::before {
    fill: var(--theme-icon-disabled-color);
  }
}

.devtools-button:empty:not([aria-expanded="true"], [aria-pressed="true"], .checked):hover {
  background: var(--toolbarbutton-hover-background);
  color: var(--toolbarbutton-hover-color);

  &::before {
    color: var(--theme-icon-hover-color);
  }
}

/* Standalone buttons */
.devtools-button.devtools-button-standalone {
  min-height: 28px;
  padding: 4px 6px;
  border: 1px solid light-dark(rgba(138, 161, 180, 0.2), var(--grey-50));
  background: var(--toolbarbutton-background);
  /* prettier-ignore */
  color: light-dark(
    var(--grey-70),
    /* In dark mode, --grey-40 will only give us a AA contrast score, but --grey-30
       is a bit too harsh, so we mix the color just enough to get a AAA score */
    color-mix(in srgb, var(--grey-30) 70%, var(--grey-40))
  );
}

/* Selectable button which is unchecked. */

.devtools-button:not(:empty, .checked, [aria-pressed="true"]):hover,
.devtools-button[aria-haspopup="menu"][aria-expanded="true"] {
  background-color: var(--toolbarbutton-hover-background);
  color: var(--toolbarbutton-hover-color);
}

.devtools-button:empty:is(.checked, [aria-pressed="true"]) {
  background-color: var(--toolbarbutton-checked-background);
}

.devtools-button:not(:empty, .checked, [aria-pressed="true"]):hover:active {
  background-color: var(--theme-selection-background-hover);
}

.devtools-togglebutton:not([aria-pressed="true"]) {
  background: var(--theme-toolbarbutton-background);
  color: var(--theme-toolbarbutton-color);
}

.devtools-togglebutton:hover:not([aria-pressed="true"], :active) {
  background-color: var(--theme-toolbarbutton-hover-background);
  color: var(--theme-toolbarbutton-hover-color);
}

/* Selectable button which is checked. */

.devtools-button:not(:empty):is(.checked, [aria-pressed="true"]) {
  background: var(--toolbarbutton-checked-background);
  color: var(--toolbarbutton-checked-color);
}

.devtools-togglebutton[aria-pressed="true"] {
  background-color: var(--theme-toolbarbutton-checked-background);
  color: var(--theme-toolbarbutton-checked-color);
  border-block-end-color: currentColor;
}

.devtools-togglebutton[aria-pressed="true"]:hover:not(:active) {
  background: var(--theme-toolbarbutton-checked-hover-background);
  color: var(--theme-toolbarbutton-checked-hover-color);
}

/* Only apply active style on non High Contrast Mode */
:root:not([forced-colors-active]) .devtools-togglebutton:active {
  background: var(--theme-toolbarbutton-active-background);
}

/* Icons */

.devtools-button.devtools-clear-icon::before {
  background-image: url("chrome://devtools/skin/images/clear.svg");
}

.devtools-option-toolbarbutton {
  list-style-image: url("chrome://devtools/skin/images/settings.svg");
}

.devtools-button.devtools-feature-callout::after {
  content: url("chrome://global/skin/icons/badge-blue.svg");
  width: 14px;
  height: 14px;
  display: block;
  position: absolute;
  top: -2px;
  right: 0;
}

/* Text input */

.devtools-textinput,
.devtools-searchinput,
.devtools-filterinput {
  appearance: none;
  margin: 0;
  padding: 0 4px;
  font: inherit;
  border: 1px solid transparent;
  background-color: var(--theme-body-background);
  color: var(--theme-body-color);
  flex-grow: 1;

  &::placeholder {
    /* override UA style */
    opacity: 1;
    /* Set a dimmed color that still gives us enough contrast  */
    color: var(--theme-text-color-alt);
  }
}

.devtools-searchinput,
.devtools-filterinput {
  padding-inline-start: 22px;
  background-position: 7px center;
  background-size: 12px;
  background-repeat: no-repeat;
  -moz-context-properties: fill;
  fill: var(--theme-icon-dimmed-color);
}

.devtools-searchinput {
  background-image: url(chrome://devtools/skin/images/search.svg);
}

.devtools-filterinput {
  background-image: url(chrome://devtools/skin/images/filter-small.svg);
}

.devtools-searchinput:-moz-locale-dir(rtl),
.devtools-searchinput:dir(rtl),
.devtools-filterinput:-moz-locale-dir(rtl),
.devtools-filterinput:dir(rtl) {
  background-position-x: right 7px;
}

.devtools-searchinput .textbox-input::placeholder,
.devtools-filterinput .textbox-input::placeholder {
  font-style: normal;
}

/* Don't show the "native" search input clear button. Wrap in :where so it's easier to
   override for specific elements.
   This should be removed when all dependencies of Bug 1956650 are fixed. */
:where(input[type="search"])::-moz-search-clear-button {
  display: none;
}

/* Searchbox with extra button(s) (MDN help or clear button) */
.devtools-searchbox {
  display: inline-flex;
  flex-grow: 1;
  gap: 4px;
  padding-inline-end: 4px;
  position: relative;
  border: 1px solid var(--searchbox-border-color);
  background-color: var(--searchbox-background-color);
  height: 100%;
  box-sizing: border-box;
}

.devtools-searchbox > .devtools-searchinput,
.devtools-searchbox > .devtools-filterinput {
  /* Those classes can be applied on <input>, which have a default styling.
     We want .devtools-searchbox to handle the background, border and outline, so we
     need to reset them here */
  background-color: transparent;
  border: none;
  outline: none;
  box-shadow: none;
  flex-grow: 1;
  min-width: 0;
  width: 100%;
}

/* Display an outline on the container when the child input is focused. If another element
   is focused (e.g. a button), we only want the outline on that element */
.devtools-searchbox:focus-within:has(input:focus-visible) {
  outline: var(--theme-focus-outline);
  outline-color: var(--theme-focus-textinput-outline-color);
  outline-offset: -2px;

  &.devtools-searchbox-no-match {
    outline-color: var(--searchbox-no-match-stroke-color);
  }
}

.devtools-searchbox-no-match {
  background-color: var(--searchbox-no-match-background-color);
  border-color: var(--searchbox-no-match-stroke-color);
}

/* Clear icon within the searchbox */
.devtools-searchinput-clear {
  flex: 0 0 auto;
  align-self: center;
  margin: 0;
  padding: 0;
  border: 0;
  width: 16px;
  height: 16px;
  background-color: transparent;
  background-image: url("chrome://devtools/skin/images/search-clear.svg");
  -moz-context-properties: fill, fill-opacity, stroke;
  fill: var(--theme-icon-color);
  fill-opacity: var(--devtools-searchinput-clear-opacity);
  stroke: var(--devtools-searchinput-clear-cross-color);

  &:hover {
    fill-opacity: 1;
    fill: var(--theme-icon-hover-color);
    stroke: var(--devtools-searchinput-clear-hover-cross-color);
  }
}

.devtools-searchbox-no-match > .devtools-searchinput-clear {
  fill: var(--searchbox-no-match-stroke-color);
}

/* MDN link within the searchbox */
.devtools-searchbox .learn-more-link::before {
  opacity: 0.6;
}

.devtools-searchbox:not(:hover) .learn-more-link {
  visibility: hidden;
}

.devtools-searchbox .devtools-searchinput-summary {
  flex-basis: auto;
  flex-grow: 0;
  flex-shrink: 0;
  color: var(--theme-comment);
  align-self: center;
}

/* Autocomplete popup within the searchbox */
.devtools-searchbox .devtools-autocomplete-popup {
  position: absolute;
  left: 0;
  top: 100%;
  width: 100%;
  line-height: initial !important;
  /* See bug - 1414609. z-index is greater than 1000 so that searchbox's z-index
  is more than z-index of requests-list-headers-wrapper in netmonitor */
  z-index: 1001;
}

/* Highlighting search results */

::highlight(devtools-search) {
  color: var(--theme-search-results-color);
  background-color: var(--theme-search-results-background);
  text-decoration: 1px underline var(--theme-search-results-border-color);
  text-decoration-skip-ink: none;
}

/* Twisty and checkbox controls */

.theme-twisty {
  width: var(--devtools-twisty-size);
  height: var(--devtools-twisty-size);
  cursor: pointer;
  background-image: url("chrome://devtools/skin/images/arrow.svg");
  background-position: center;
  background-repeat: no-repeat;
  background-size: 10px;
  -moz-context-properties: fill;
  /* Set color and use currentColor in fill so we adapt in High Contrast Mode */
  color: var(--theme-icon-dimmed-color);
  fill: currentColor;
  transform: rotate(-90deg);
}

/* Mirror the twisty for rtl direction */
.theme-twisty:dir(rtl),
.theme-twisty:-moz-locale-dir(rtl) {
  transform: rotate(90deg);
}

.theme-selected ~ .theme-twisty {
  color: var(--theme-selection-color);
}

.theme-twisty:is(.open, [open], [aria-expanded="true"]) {
  transform: none;
}

.theme-twisty[invisible] {
  visibility: hidden;
}

/* Throbbers */
.devtools-throbber::before {
  content: "";
  display: inline-block;
  vertical-align: bottom;
  margin-inline-end: 0.5em;
  width: 1em;
  height: 1em;
  border: 2px solid currentColor;
  border-right-color: transparent;
  border-radius: 50%;
  animation: 1.1s linear throbber-spin infinite;
}

@keyframes throbber-spin {
  from {
    transform: none;
  }
  to {
    transform: rotate(360deg);
  }
}

/* Common tabs styles */

.all-tabs-menu {
  position: absolute;

  top: 0;
  inset-inline-end: 0;
  width: 15px;
  height: 100%;

  padding: 0;
  border: none;
  border-inline-start: 1px solid var(--theme-splitter-color);

  background: var(--theme-tab-toolbar-background);
  background-image: url("chrome://devtools/skin/images/dropmarker.svg");
  background-repeat: no-repeat;
  background-position: center;
  -moz-context-properties: fill;
  fill: var(--theme-icon-color);
  /* The button is often displayed next to the window edge, so adjust the layout to make the offset visible */
  outline-offset: -2px;
}

.all-tabs-menu:hover {
  background-color: var(--theme-toolbar-hover);
}

.all-tabs-menu:hover:active {
  background-color: var(--theme-toolbar-hover-active);
}

.devtools-tab-line {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 2px;
  background: transparent;
  transition:
    transform 250ms var(--animation-curve),
    opacity 250ms var(--animation-curve);
  opacity: 0;
  transform: scaleX(0);

  :root[forced-colors-active] & {
    display: none;
  }
}

.devtools-tab:hover .devtools-tab-line,
.tabs-menu-item:hover .devtools-tab-line {
  background: var(--tab-line-hover-color);
  opacity: 1;
  transform: scaleX(1);
}

.devtools-tab.selected .devtools-tab-line,
/* don't show the line when focus is visible to prevent overlapping with the outline */
.tabs-menu-item.is-active .devtools-tab-line:not(:has(+ [role="tab"]:focus-visible)) {
  background: var(--tab-line-selected-color);
  opacity: 1;
  transform: scaleX(1);
}

@media (prefers-reduced-motion) {
  .devtools-tab-line {
    transition: none;
  }
}

.devtools-tab:not(.selected):focus .devtools-tab-line {
  background: var(--tab-line-hover-color);
  opacity: 1;
  transform: scaleX(1);
}

/* No result message styles */

.devtools-sidepanel-no-result {
  font-style: italic;
  padding: 0.5em 20px;
  user-select: none;
  font-size: 12px;
  line-height: calc(16 / 12);
}

/* Checkbox Toggle */

.devtools-checkbox-toggle {
  --x-pos: 0.15em;
  /* Reset native checkbox styling. */
  appearance: none;
  background-color: var(--toggle-track-color);
  cursor: pointer;
  /* Change font-size to scale. */
  font-size: 16px;
  width: 2em;
  height: 1em;
  border-radius: 1em;
  border: 1px solid var(--toggle-track-border-color);
  box-sizing: content-box;

  &:checked {
    --x-pos: 1.15em;
    background-color: var(--toggle-track-color-pressed);
  }

  &:hover:not(:active, [disabled]) {
    background-color: var(--toggle-hover-track-color);
    border-color: var(--toggle-hover-track-border-color);

    &:checked {
      background-color: var(--toggle-hover-track-color-pressed);
    }

    &:not(:checked)::before {
      background-color: var(--toggle-hover-thumb-color);
    }
  }

  &[disabled] {
    opacity: var(--toggle-track-disabled-opacity);
    --toggle-track-border-color: var(--toggle-disabled-track-border-color);
    --toggle-track-color-pressed: var(--toggle-disabled-track-color-pressed);
    --toggle-thumb-color: var(--toggle-disabled-thumb-color);
  }
}

/* For right-to-left layout, the toggle thumb goes in the opposite direction. */
html[dir="rtl"] .devtools-checkbox-toggle {
  --x-pos: -0.15em;
}

html[dir="rtl"] .devtools-checkbox-toggle:checked {
  --x-pos: -1.15em;
}

.devtools-checkbox-toggle::before {
  position: relative;
  width: calc(1em - 0.3em);
  height: calc(1em - 0.3em);
  transform: translateY(0.15em) translateX(var(--x-pos));
  border-radius: 100%;
  display: block;
  content: "";
  background-color: var(--toggle-thumb-color);
  transition: transform 0.1s ease-out;
}

.devtools-checkbox-toggle:checked::before {
  background-color: var(--toggle-thumb-color-pressed);
}

/* Remove transition on toggle when prefers reduced motion is enabled */
@media (prefers-reduced-motion) {
  .devtools-checkbox-toggle,
  .devtools-checkbox-toggle::before {
    transition: none;
  }
}

.devtools-checkered-background {
  background-color: #eee;
  background-image:
    linear-gradient(45deg, #ccc 25%, transparent 25%, transparent 75%, #ccc 75%, #ccc),
    linear-gradient(45deg, #ccc 25%, transparent 25%, transparent 75%, #ccc 75%, #ccc);
  background-size: 20px 20px;
  background-position:
    0 0,
    10px 10px;
}

/******************************************************************************/
/* Jump to definition button */

button.jump-definition {
  display: inline-block;
  height: 16px;
  width: 20px;
  margin-left: 0.25em;
  vertical-align: middle;
  background: center url("chrome://devtools/content/shared/components/reps/images/jump-definition.svg") no-repeat;
  border-color: transparent;
  stroke: var(--theme-icon-color);
  -moz-context-properties: stroke;
  cursor: pointer;
}

button.jump-definition:hover {
  stroke: var(--theme-icon-checked-color);
}

:root[forced-colors-active] button.jump-definition {
  border: 1px solid ButtonText;
  border-radius: 2px;
  background-color: ButtonFace;
}

:root[forced-colors-active] button.jump-definition:hover {
  stroke: var(--theme-icon-hover-color);
  border-color: var(--theme-icon-hover-color);
}

/* In High Contrast Mode, the button has a solid background, so we only need
    to set a different color for the icon when we are not in HCM */
:root:not([forced-colors-active]) .tree-node.focused button.jump-definition {
  stroke: currentColor;
}